package org.jboss.security.auth.spi;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.security.Principal;
import java.security.acl.Group;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import org.jboss.security.SimpleGroup;
import org.jboss.security.SimplePrincipal;
import org.jboss.security.auth.spi.Users;

public class User implements Comparable {
  private String name;
  
  private String password;
  
  private String encoding;
  
  private HashMap roleGroups = new HashMap();
  
  public User() {}
  
  public User(String name) {
    this.name = name;
  }
  
  public String getName() {
    return this.name;
  }
  
  public void setName(String name) {
    this.name = name;
  }
  
  public String getPassword() {
    return this.password;
  }
  
  public void setPassword(String password) {
    this.password = password;
  }
  
  public String getEncoding() {
    return this.encoding;
  }
  
  public void setEncoding(String encoding) {
    this.encoding = encoding;
  }
  
  public Group[] getRoleSets() {
    Group[] roleSets = new Group[this.roleGroups.size()];
    this.roleGroups.values().toArray((Object[])roleSets);
    return roleSets;
  }
  
  public String[] getRoleNames() {
    return getRoleNames("Roles");
  }
  
  public String[] getRoleNames(String roleGroup) {
    Group group = (Group)this.roleGroups.get(roleGroup);
    String[] names = new String[0];
    if (group != null) {
      ArrayList tmp = new ArrayList();
      Enumeration iter = group.members();
      while (iter.hasMoreElements()) {
        Principal p = iter.nextElement();
        tmp.add(p.getName());
      } 
      names = new String[tmp.size()];
      tmp.toArray(names);
    } 
    return names;
  }
  
  public void addRole(String roleName, String roleGroup) {
    SimpleGroup simpleGroup;
    Group group = (Group)this.roleGroups.get(roleGroup);
    if (group == null) {
      simpleGroup = new SimpleGroup(roleGroup);
      this.roleGroups.put(roleGroup, simpleGroup);
    } 
    SimplePrincipal role = new SimplePrincipal(roleName);
    simpleGroup.addMember((Principal)role);
  }
  
  public int compareTo(Object obj) {
    User u = (User)obj;
    return this.name.compareTo(u.name);
  }
  
  public String toString() {
    return "User{name='" + this.name + "'" + ", password=*" + ", encoding='" + this.encoding + "'" + ", roleGroups=" + this.roleGroups + "}";
  }
}
